// adapted from hurdy, for aeio
// new : 2-phase single pulse oscillator

// changed 20071109 : noteoffset /signed/ char

#include "system.h"
#include <math.h>
#include "TimerSynth.h"

unsigned long Garbage[32]; // for Icd2 agent

int pitchBend1;
int pitchBend2;

char 	Osc1Enable;
char 	Osc1Note;
signed char NoteOffset1;
WORD_VAL Period1;
WORD_VAL t1;
WORD_VAL t2;
WORD_VAL t3;
WORD_VAL t4;
char 	Flageolet1;
int 	DutyCycle1;
int 	DutyCycle2;
volatile int	StateTimer1;


unsigned long TuneTable1[128];
//unsigned long TuneTable2[128];


#define PHASE1 LATEbits.LATE1
#define PHASE2 LATEbits.LATE3

void Osc1NoteOff()
{
	T2CONbits.TON = 0;
	PHASE1 = 1;
	PHASE2 = 1;
	Osc1Note = -1;
}

void Osc1Calc()
{
	WORD_VAL duty;
	WORD_VAL cycle;
	WORD_VAL ctl;
//	unsigned int dutycycle;
//	unsigned char overtone;

//	if ((Osc1Note>=40) && (Osc1Note<=63))
	{
		
		if (((Osc1Note+NoteOffset1)>0) &&
			((Osc1Note+NoteOffset1)<127) &&
			(Osc1Note!=-1))
		{
			float u = (float)TuneTable1[Osc1Note+NoteOffset1];
			u /= Flageolet1;
			u *= pow(2.0f,-(float)pitchBend1/1200.0f);
			Period1.uval = (long)u;
//			Period1.uval = TuneTable1[Osc1Note+NoteOffset1];
//			Period1.uval = Period1.uval / Flageolet1;
			
			duty.uval = __builtin_muluu(MSBi(Period1),DutyCycle1)
				+ (__builtin_muluu(LSBi(Period1),DutyCycle1)>>16);
		
			cycle.uval = Period1.uval - duty.uval;
			
			t1.uval = /*0xffffffff -*/ duty.uval - 0x11;
			t2.uval = /*0xffffffff - */cycle.uval - 0x11;

			duty.uval = __builtin_muluu(MSBi(Period1),DutyCycle2)
				+ (__builtin_muluu(LSBi(Period1),DutyCycle2)>>16);
		
			cycle.uval = Period1.uval - duty.uval;
			
			t3.uval = /*0xffffffff -*/ duty.uval - 0x11;
			t4.uval = /*0xffffffff - */cycle.uval - 0x11;

			ctl.uval = t1.uval + t2.uval + t3.uval + t4.uval;
			T2CONbits.TON = 1;
		}
		else
		Osc1NoteOff();
	}
}


void Osc1NoteOn(char note)
{
//	WORD_VAL period;
	Osc1Note = note;
	Osc1Calc();
}

void InitTable(void)
{
	unsigned char i;
	for(i=0;i<128;i++)
	{
		TuneTable1[i]=(unsigned long)((30e6 / 440)*pow(2.0,(69-i)/12.0));
//		TuneTable2[i]=(unsigned long)((30e6 / 440)*pow(2.0,(69-i)/12.0));
	}
	pitchBend1 = 0;
}

void InitTimer23(void)
{
	InitTable();
	DutyCycle1 = 0x1000;
	Flageolet1 = 1;
	
//	CalcPitch(7,0x9000);
	PR2 = 0xFFFF;
	PR3 = 0xFFFF;
	T2CONbits.T32 = 1;
	T2CONbits.TCKPS = 0;
	T2CONbits.TON = 0;	


	t1.val = 0x00010000 - 0x11;
	t2.val = 0x00020000 - 0x10;
	t3.val = 0x00010000 - 0x11;
	t4.val = 0x00020000 - 0x10;
	TMR2 = 0xFFF0;
	TMR3 = 0xFFFF;	
	
//	Osc1NoteOn(69);
	Osc1NoteOff();

	// enable interrupt
	IFS0bits.T3IF = 0;
	IEC0bits.T3IE = 1;
	IPC1bits.T3IP = 7;	


	TRISEbits.TRISE1 = 0;
	LATEbits.LATE1 = 1;
	TRISEbits.TRISE3 = 0;
	LATEbits.LATE3 = 1;
//	TRISB = 0x00;
}


void _ISR _T3Interrupt( void )
{
	WORD_VAL tmp;
	IFS0bits.T3IF = 0;
	
//	tmp.val = 0;
//	tmp.val++;	
	
	LSBi(tmp) = TMR2;
	MSBi(tmp) = TMR3HLD;

	if (StateTimer1 == 0)
	{
		tmp.val -= t1.val;
		TMR3HLD = MSBi(tmp);	
		TMR2 = LSBi(tmp);
		PHASE1 = 0;
		PHASE2 = 1;
		StateTimer1 = 1;
	}
	else if (StateTimer1 == 1)
	{
		tmp.val -= t2.val;
		TMR3HLD = MSBi(tmp);	
		TMR2 = LSBi(tmp);
		PHASE1 = 1;
		PHASE2 = 1;
		StateTimer1 = 2;
	}
	else if (StateTimer1 == 2)
	{
		tmp.val -= t3.val;
		TMR3HLD = MSBi(tmp);	
		TMR2 = LSBi(tmp);
		PHASE1 = 1;
		PHASE2 = 0;
		StateTimer1 = 3;
	}
	else 
	{
		tmp.val -= t4.val;
		TMR3HLD = MSBi(tmp);	
		TMR2 = LSBi(tmp);
		PHASE1 = 1;
		PHASE2 = 1;
		StateTimer1 = 0;
	}
	if (tmp.val > 0)
	{
		tmp.val = -10;
		TMR3HLD = MSBi(tmp);	
		TMR2 = LSBi(tmp);		
	}	
}
